#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <unistd.h>



#include "dns.h"
#include "month.h"

#define LEN	4096

/* Strukturen */
typedef struct tagENT {
	char    ipname[64];
	int  	  anz;
	long	  bytes;
	struct tagENT *next;
} ENTRY;


/****************************************************************/
/* globale Variablen  -    Erlaeuterungen 						*/
/****************************************************************/
ENTRY *start=NULL, 			/* Anfang der verketteten Liste 			*/
		*last=NULL;			/* Ende der verketteten Liste 				*/
int 	typ = 0;			/* Unterscheidung zwischen Squid+Apache */
int 	bDNS=0;				/* wird eine DNS-Anfrage gemacht ? 			*/
int 	bSORT=0;			/* Ausgabe sortieren ? 						*/
int 	bKILO=0;			/* Ausgabe in MB.kB.B ?						*/
int 	bSTDIN=0;			/* STDIN als Eingabedatei...				*/
unsigned long 	summe=0;			/* Summe aller MB's							*/
int		trunc=0;			/* abschneiden nach xxx zeichen 			*/
char	z1[LEN], z2[LEN], z3[LEN];	/* Erste und letzte Zeile 					*/
char 	infile[256];		/* Logdatei des Proxies						*/
char 	outdir[256];		/* Ausgabeverzeichnis						*/




/******************************************************************/
/* wie benutz ich das Teil ?                                      */
/******************************************************************/
void usage(int exitcode)
{
	printf("usage: panalyze \n");
	printf("\t-g   generates a config file\n");
	exit (exitcode);
}	

/******************************************************************/
/* suche nach einem Eintrag in der Liste                          */
/******************************************************************/
ENTRY *find(char *search)
{
	ENTRY *lauf;

	lauf = start;
	while (lauf)
	{
		if (!strcmp(search, lauf->ipname))
			break;

		lauf = lauf->next;
	}	
	return lauf;
}



/******************************************************************/
/* fuege ggfs. eine IP-Adresse in die Liste ein                   */
/******************************************************************/
int insert(char *ipname, long bytes)
{
	ENTRY *help;
	char  teststr[32];

	strncpy(teststr, ipname, 31);
	teststr[31] = 0;

	if (strchr(teststr, '%') || strchr(teststr,'&') || strchr(teststr, ' ')) 
		return (-1);
	
	if (start==NULL) 
	{
		start       = malloc(sizeof(ENTRY));
		strcpy(start->ipname, teststr);
		start->anz  = 1;
		start->bytes= bytes;
		start->next = NULL;
		last        = start;
		return 0;
	}

	help = find(ipname);

	if (help==NULL) 	/* Neuer Eintrag */
	{
		help       = malloc(sizeof(ENTRY));
		strcpy(help->ipname, teststr);
		help->anz  = 1;
		help->bytes = bytes;
		help->next = NULL;

		last->next = help;
		last       = help;
		return 1;
	}


	/* bestehender Eintrag */
	if (bytes<0) bytes = 0;

	help->anz   += 1;
	help->bytes += bytes;

	return 2;
}


/******************************************************************/
/* formatiert eine Zahl in MB um                                  */
/******************************************************************/
char *b2mb(long bytes)
{
	static char ret[64];
	long 	gb, mb, kb, bb;

	gb = bytes / 1073741824;
	mb = bytes / 1048576;
	kb = bytes / 1024;
	bb = bytes - (kb * 1024) - (mb * 1048576) - (gb * 1073741824);

	if (bKILO) 
	{
		if (gb)
		{
			if (mb>512) gb++;
			sprintf(ret, "%ldGB", gb);
		}
		else {
			if (mb) 
			{
				if (kb>512) mb++;
				sprintf(ret, "%ldMB", mb);
			}
			else {
				if (kb)
				{
					if (bb>512) kb++;
					sprintf(ret, "%ldkB", kb);
				}
				else
				{
					sprintf(ret, "%ldB", bb);
				}
			}
		}
	}
	else 
		sprintf(ret, "%ld", bytes);
		

	return ret;
}

void printline(int i)
{
	int j;
	for (j=0; j<i; j++)
		printf("%c", '-');
	printf("\n");
}	

/******************************************************************/
/* suche das Datum ...                                            */
/******************************************************************/
char *datum(char *zeile)
{
	char *pstr,tag[3], mon[4], jah[5], work[LEN];
	char *retstr;

	strcpy(work,zeile);

	pstr = strtok(work, "[");
	pstr = strtok(NULL,  ":");
	if (pstr)
	{
		retstr = malloc(32);
		if (!retstr) return ("");

		strncpy(tag, pstr,   2); tag[2] = '\0';
		strncpy(mon, pstr+3, 3); mon[3] = '\0';
		strncpy(jah, pstr+7, 4); jah[4] = '\0';
		sprintf(retstr, "%s.%02d.%s", tag, 1+getmonth(mon), jah);
		return (retstr);
	}
	return ("");
}

char *zeit(char *zeile)
{
	char *pstr, uhr[5], work[LEN];
	static char retstr[32];

	strcpy(work,zeile);

	pstr = strtok(zeile, "[");
	pstr = strtok(NULL,  "]");
	if (pstr)
	{
		strncpy(uhr, pstr+12,5); uhr[5] = '\0';
		sprintf(retstr, "%s", uhr);
		return (retstr);
	}
	return ("");
}


/******************************************************************/
/* gib das Ergebnis aus                                           */
/******************************************************************/
void printlist(ENTRY *anf)
{
	ENTRY *lauf;
	FILE *fp, *fo;
	char hostfile[512], outfile[512];

	sprintf(outfile, "%s/index.html", outdir);
	fp = fopen(outfile, "w");
	if (fp) {
		fprintf(fp,"<html>\n<head><title>Proxyauswertung</title></head>\n");
		fprintf(fp, "<frameset cols=\"350,*\">\n");
		fprintf(fp, " <frame src=\"./rechner.html\" name=rechner resize=no>\n");
		fprintf(fp, " <frameset rows=\"350,*\">\n");
		fprintf(fp, "  <frame src=\"./null.html\" 	name=inhalt>\n");
		fprintf(fp, "  <frame src=\"./null.html\" 	name=what>\n");
		fprintf(fp, " </frameset>\n");
		fprintf(fp, "</frameset>\n");
		fprintf(fp,"<body link=blue vlink=blue alink=red bgcolor=white>\n");
		fprintf(fp, "&nbsp;</body></html>\n");
	}
	fclose(fp);
	
	sprintf(outfile, "%s/null.html", outdir);
	fp = fopen(outfile, "w");
	if (fp) {
		fprintf(fp,"<html><head><title>&nbsp;</title></head>\n");
		fprintf(fp,"<body link=blue vlink=blue alink=red bgcolor=white>\n");
		fprintf(fp, "&nbsp;</body></html>\n");
	}
	fclose(fp);

	sprintf(outfile, "%s/rechner.html", outdir);
	fp = fopen(outfile,"w");
	if (fp) {
		fprintf(fp,"<html><head><title>\n");
		fprintf(fp,"Auswertung des Proxy-Servers</title></head>\n");
		fprintf(fp,"<body link=blue vlink=blue alink=red bgcolor=white>\n");

		fprintf(fp, "<table width=260 border=0 cellpadding=0 cellspacing=5>\n");
		fprintf(fp, "<tr><td colspan=2><b>%s-Statistik</b></td></tr>", 
			typ==0?"Proxy":"Apache");

		fprintf(fp, "<tr><td colspan=2>%s - %s</td></tr>\n", 
		 	datum(z1), datum(z2));


		fprintf(fp, "<tr><td colspan=2><hr></td></tr>\n");

		lauf = start;
		while (lauf)
		{
			sprintf(hostfile, "%s/%s.html",outdir, lauf->ipname);

			fprintf(fp, "<tr>\n");
			
			fprintf(fp, "<td><a href=\"./%s.html.gz\" target=inhalt>%s</a></td>\n",
					lauf->ipname, 
					bDNS==1?dnsquery(lauf->ipname):lauf->ipname);

			fprintf(fp,"<td align=right>%12s</td>\n", 	
					b2mb(lauf->bytes));
					summe += lauf->bytes;
			fprintf(fp, "</tr>\n");
			
			fo = fopen(hostfile, "a");
			if (fo) fprintf(fo, "\n</body>\n</html>\n");
			fclose(fo);
			lauf = lauf->next;
		}	
		
		fprintf(fp,"<tr><td colspan=2><hr></td></tr>\n");
		fprintf(fp,"<tr><td>&nbsp;</td><td align=right>%54s</td></tr>\n",
			 b2mb(summe));

		fprintf(fp, "</table>\n");

		fprintf(fp,"</body></html>\n");
	}
}

void no_ws(char *p)
{
	char *q;
	
	q = p;
	if (q) {
		while (*q=='\t' || *q==' ') q++;
		strcpy(p,q);
	}
}

int getarg(char *zp, char *str)
{
	char *p,*q;
	
	if (*zp == '#') return 0;

	p = strtok(zp,   " \t");
	if (p) {
		q = strtok(NULL, "\r\n");
		if (q) {
			no_ws(q);
			if (q) strcpy(str, q);
	
			if (0==strcmp(p, "Input")) 		return 1;
			if (0==strcmp(p, "Output")) 	return 2;
			if (0==strcmp(p, "DNS")) 		return 3;
			if (0==strcmp(p, "Sort")) 		return 4;
			if (0==strcmp(p, "Kilo")) 		return 5;
			if (0==strcmp(p, "Truncate")) 	return 6;
		}
	}
	return 0;
}

/******************************************************************/
/* prueft die Argumentliste                                       */
/******************************************************************/
int checkargs()
{
	int 	in=0,out=0,ai=0;
	char 	zeile[512], as[256];
	FILE 	*fp;

	fp = fopen("/etc/panalyze.conf", "r");
	if (fp) {
		while (NULL != fgets(zeile, sizeof(zeile), fp)) {
			no_ws(zeile);

			ai = getarg(zeile, as);
			switch(ai) {
			case 0: 
				break;

			case 1: 
				strcpy(infile, as);
				in = 1;
				break;

			case 2: 
				sprintf(outdir,  "%s", as);
				out=1;
				break;

			case 3:
				if (0==strcmp(as, "TRUE")) bDNS = 1;
				break;

			case 4:
				if (0==strcmp(as, "TRUE")) bSORT= 1;
				break;

			case 5:
				if (0==strcmp(as, "TRUE")) bKILO= 1;
				break;
			
			case 6:
				trunc = atoi(as);
				break;
			}
		}
		fclose(fp);

		if (in && out) return 1;
		else {
			printf("Not all parameters set!\n");
			return 0;
		}
	}
	else {
		printf("Could not open /etc/panalyze.conf!\n");
	}

	return 0;
}


/******************************************************************/
/* sortiert die Liste nach Anzahl Bytes :-)                       */
/******************************************************************/
void sortlist(ENTRY *anf)
{
	ENTRY	*comp, *lauf;
	char	h_ipname[64];
	long	h_bytes;
	int	h_anz;

	comp = start;

	while (comp) 
	{
		lauf = comp->next;
		while (lauf)
		{
			if (lauf->bytes < comp->bytes) 
			{	/* tauschen */
				strcpy(h_ipname, lauf->ipname);
				h_bytes = lauf->bytes;
				h_anz   = lauf->anz;

				strcpy(lauf->ipname, comp->ipname);
				lauf->bytes = comp->bytes;
				lauf->anz   = comp->anz;

				strcpy(comp->ipname, h_ipname);
				comp->bytes = h_bytes;
				comp->anz   = h_anz;
			}
			lauf = lauf->next;
		}
		comp = comp->next;
	}
}

int badurl(char *str)
{
	int len=strlen(str);
	char *p = str + len -5;

	/* Gelb machen */ 
	if (strstr(p, ".jpg")) return 1;
	if (strstr(p, ".JPG")) return 1;
	if (strstr(p, ".gif")) return 1;
	if (strstr(p, ".GIF")) return 1;

	/* Rot machen */ 
	if (strstr(p, ".exe")) return 2;
	if (strstr(p, ".EXE")) return 2;
	if (strstr(p, ".zip")) return 2;
	if (strstr(p, ".ZIP")) return 2;

	return 0;
}

/******************************************************************/
/* das Hauptprogramm                                              */
/******************************************************************/
int main(int argc, char **argv)
{
	FILE *fp, *fo;
	int  check=0, arg=0, erg=0,val=0,l=0;
	unsigned int u1,u2,u3,u4;
	char zeile[LEN];
	char ipname[64], getstr[1024], hilf[1024], bytes[64];
	char hostfile[256], syscmd[512];
	char *st, *p, *co;
	char merk[32], neu[32];

	strcpy(merk, "");
	arg = checkargs();

	fp = fopen(infile, "r");
	if (!fp) 
	{
		usage(1);
	}

	
	sprintf(syscmd, "rm -rf %s/*.html*", outdir);
	system(syscmd);
	check = 0;

	while (NULL!=fgets(zeile, sizeof(zeile), fp))
	{
		if (check == 0)
		{
			check = 1;
			/* Erste Zeile... */
			strcpy(z1, zeile);
		}

		/* Letzte Zeile... */
		/* erste und letzte Zeile brauch ich fuers Datum */
		strcpy(z2, zeile);
		strcpy(z3, zeile);

		st = strtok(zeile, " ");
		if (NULL!=st)
		{
			strcpy(ipname, st);

			st = strtok(NULL, "\"");
			st = strtok(NULL, "\"");
			if (NULL!=st) 
			{
				strcpy(getstr,  st);
			}

			st = strtok(NULL, " ");
			if (NULL!=st) 
			{
				if (!check)
				{
					if (atoi(st)>0)
						typ = 1;
					check = 1;
				}
					
			}
			st = strtok(NULL, " ");
			if (NULL!=st) 
			{
				strcpy(bytes,  st);
			}
			

			p = strchr(getstr, '?');
			if (p) *p = 0;
			p = strstr(getstr, " HTTP/");
			if (p) *p = 0;

			co = strstr(getstr, "GET ");
			if ((co) && sscanf(ipname, "%u.%u.%u.%u", &u1,&u2,&u3,&u4) == 4 )
			{

				/* Anfangskram */
				p = strstr(getstr, " http://");
				if (!p) p = strstr(getstr, " ftp://");
				if (p) strcpy(getstr, p+1);
		

				sprintf(hostfile, "%s/%s.html", outdir, ipname);

				fo = fopen(hostfile, "r");
				if (!fo) {
					fo = fopen(hostfile, "w");
					fprintf(fo, "<html>\n");
					fprintf(fo, "<head>\n");
					fprintf(fo, "<meta http-equiv=\"expires\" content=\"10\">\n");
					fprintf(fo, "</head>\n");
					fprintf(fo, "<body link=blue vlink=blue alink=red bgcolor=white>\n");
					fprintf(fo, "<b>%s</b><hr>\n", dnsquery(ipname));
				}
				else {
					fclose(fo);
					fo = fopen(hostfile, "a");
				}

	
				if (fo) {
					strcpy(neu, datum(z3));
	
					fprintf(fo, "<font size=1>");
					fprintf(fo, " %s ", neu);
					fprintf(fo, " %s ", zeit(z3));
					fprintf(fo, "</font>");
					val = badurl(getstr);
					switch(val) {
					case 0: 
						fprintf(fo, " <font color=white><b>*</b></font>\n");
						break;
					case 1:
						fprintf(fo, " <font color=green><b>*</b></font>\n");
						break;
					case 2:
						fprintf(fo, " <font color=red><b>*</b></font>\n");
						break;
					}
	
					l = strlen(getstr);
					if (l > trunc) {
						strncpy(hilf, getstr, trunc);
						hilf[trunc] = 0;
						strcat(hilf, "...");
					}
					else 	
						strcpy(hilf,getstr);
	
					fprintf(fo, " <a href=\"%s\" target=\"what\">", getstr);
					fprintf(fo, " <font size=2>%s</font></a><br>\n", hilf);
					
				}
				fclose(fo);

				erg = insert(ipname, atol(bytes));

			}
		}
	}
	fclose(fp);

	if (bSORT) sortlist(start);
	printlist(start);

	sprintf(syscmd, "gzip %s/*.*.*.*.*html", outdir);
	system (syscmd);

	return 0;
}

